﻿using System;

namespace PvrSharp.Formats
{
	public class La88 : IColorFormat
	{
		private static La88 instance;

		public static La88 Instance
		{
			get { return instance ?? (instance = new La88()); }
		}

		public bool HasAlpha { get { return true; } }

		private La88()
		{
		}

		public byte[] ConvertToRgb888(PvrFile file, int sourceOffset)
		{
			var result = new byte[file.Width * file.Height * 3];
			int destinationIndex = 0;
			int sourceIndex = sourceOffset;
			for (int rowIndex = 0; rowIndex < file.Height; rowIndex++)
			{
				for (int pixelIndex = 0; pixelIndex < file.Width; pixelIndex++)
				{
					byte l = file.RawPixelData[sourceIndex++];
					sourceIndex++;
					result[destinationIndex++] = l;
					result[destinationIndex++] = l;
					result[destinationIndex++] = l;
				}
			}

			return result;
		}

		public byte[] ConvertToRgb8888(PvrFile file, int sourceOffset)
		{
			var result = new byte[file.Width * file.Height * 4];
			int destinationIndex = 0;
			int sourceIndex = sourceOffset;
			for (int rowIndex = 0; rowIndex < file.Height; rowIndex++)
			{
				for (int pixelIndex = 0; pixelIndex < file.Width; pixelIndex++)
				{
					byte l = file.RawPixelData[sourceIndex++];
					byte a = file.RawPixelData[sourceIndex++];
					result[destinationIndex++] = l;
					result[destinationIndex++] = l;
					result[destinationIndex++] = l;
					result[destinationIndex++] = a;
				}
			}

			return result;
		}
	}
}
