﻿using System;

namespace PvrSharp.Formats
{
	public class R8 : IColorFormat
	{
		private static R8 instance;

		public static R8 Instance
		{
			get { return instance ?? (instance = new R8()); }
		}

		public bool HasAlpha { get { return false; } }

		private R8()
		{
		}

		public byte[] ConvertToRgb888(PvrFile file, int sourceOffset)
		{
			var result = new byte[file.Width * file.Height * 3];
			int destinationIndex = 0;
			int sourceIndex = sourceOffset;
			for (int rowIndex = 0; rowIndex < file.Height; rowIndex++)
			{
				for (int pixelIndex = 0; pixelIndex < file.Width; pixelIndex++)
				{
					byte r = file.RawPixelData[sourceIndex++];
					if (file.ChannelType == PvrChannelType.SignedByte)
					{
						// TODO
					}
					else if (file.ChannelType == PvrChannelType.UnsignedByteNormalized)
					{
						// TODO
					}
					else if (file.ChannelType == PvrChannelType.SignedByteNormalized)
					{
						// TODO
					}

					result[destinationIndex++] = r;
					result[destinationIndex++] = 0;
					result[destinationIndex++] = 0;
				}
			}

			return result;
		}

		public byte[] ConvertToRgb8888(PvrFile file, int sourceOffset)
		{
			var result = new byte[file.Width * file.Height * 4];
			int destinationIndex = 0;
			int sourceIndex = sourceOffset;
			for (int rowIndex = 0; rowIndex < file.Height; rowIndex++)
			{
				for (int pixelIndex = 0; pixelIndex < file.Width; pixelIndex++)
				{
					byte r = file.RawPixelData[sourceIndex++];
					result[destinationIndex++] = r;
					result[destinationIndex++] = 0;
					result[destinationIndex++] = 0;
					result[destinationIndex++] = 255;
				}
			}

			return result;
		}
	}
}
