﻿using System;

namespace PvrSharp.Formats
{
	public class Rgb888 : IColorFormat
	{
		private static Rgb888 instance;

		public static Rgb888 Instance
		{
			get { return instance ?? (instance = new Rgb888()); }
		}

		public bool HasAlpha { get { return false; } }

		private Rgb888()
		{
		}

		public byte[] ConvertToRgb888(PvrFile file, int sourceOffset)
		{
			var result = new byte[file.Width * file.Height * 3];
			int destinationIndex = 0;
			int sourceIndex = sourceOffset;
			for (int rowIndex = 0; rowIndex < file.Height; rowIndex++)
			{
				for (int pixelIndex = 0; pixelIndex < file.Width; pixelIndex++)
				{
					result[destinationIndex++] = file.RawPixelData[sourceIndex++];
					result[destinationIndex++] = file.RawPixelData[sourceIndex++];
					result[destinationIndex++] = file.RawPixelData[sourceIndex++];
				}
			}

			return result;
		}

		public byte[] ConvertToRgb8888(PvrFile file, int sourceOffset)
		{
			throw new NotImplementedException();
		}
	}
}
