﻿using System;
using System.Collections.Generic;
using System.IO;

namespace PvrSharp
{
	public class PvrMetaDataCollection
	{
		private readonly List<PvrMetaData> entries;

		public int Count
		{
			get { return entries.Count; }
		}

		public PvrMetaData this[int index]
		{
			get { return entries[index]; }
		}

		private PvrMetaDataCollection()
		{
			entries = new List<PvrMetaData>();
		}

		internal static PvrMetaDataCollection FromStream(BinaryReader reader)
		{
			var result = new PvrMetaDataCollection();

			uint metaDataChunkSize = reader.ReadUInt32();
			long positionBeforeMetaDataRead = reader.BaseStream.Position;
			while (reader.BaseStream.Position < positionBeforeMetaDataRead + metaDataChunkSize)
				result.entries.Add(PvrMetaData.FromStream(reader));

			return result;
		}
	}
}
